// _advanced expert advisor template.mq4
// Copyright  2009, TradingSystemForex
// http://www.tradingsystemforex.com/

#property copyright "Copyright  2009, TradingSystemForex"
#property link "http://www.tradingsystemforex.com/"

extern bool fullcomment=false;           // display comments on the screen to monitor the account
extern bool showequityonchart=false;     // show the evolution of the equity on chart
extern string comment="TDS";             // comment to display in the order
extern int magic=1234;                   // magic number required if you use different settings on a same pair, same timeframe

extern string moneymanagement="Money Management";

extern double lots=0.01;                 // lots size
extern bool lotsoptimized=true;          // enable risk management
extern double risk=1;                    // risk in percentage of the account
extern double minlot=0.01;               // minimum lot allowed by the expert
extern double maxlot=10;                 // maximum lot allowed by the expert
extern double lotdigits=2;               // 1 for minilot, 2 for microlot
extern bool basketpercent=false;         // enable the basket percent
extern double profit=10;                 // close all orders if a profit of 10 percents has been reached
extern double loss=30;                   // close all orders if a loss of 30 percents has been reached

extern string ordersmanagement="Order Management";

extern bool oppositeclose=true;          // close the orders on an opposite signal
extern bool reversesignals=false;        // reverse the signals, long if short, short if long
extern int maxtrades=100;                // maximum trades allowed by the expert
extern int tradesperbar=1;               // maximum trades per bar allowed by the expert
extern bool hidestop=false;              // hide stop loss
extern bool hidetarget=true;             // hide take profit
extern int buystop=0;                    // buy stop loss
extern int buytarget=11;                 // buy take profit
extern int sellstop=0;                   // sell stop loss
extern int selltarget=11;                // buy take profit
extern int trailingstart=0;              // profit in pips required to enable the trailing stop
extern int trailingstop=0;               // trailing stop
extern int trailingstep=1;               // margin allowed to the market to enable the trailing stop
extern int breakevengain=0;              // gain in pips required to enable the break even
extern int breakeven=0;                  // break even
extern int slippage=5;                   // maximum difference in pips between signal and order
extern double maxspread=20;              // maximum spread allowed by the expert

extern string entrylogics="Entry Logics";

extern int shift=1;                      // bar in the past to take in consideration for the signal
extern bool timeframe1=true;             // enable the donchian channel on M1
extern int timeframe1period=3;           // period of the donchian channel on M1
extern bool timeframe5=false;            // enable the donchian channel on M5
extern int timeframe5period=12;          // period of the donchian channel on M5
extern bool timeframe15=false;           // enable the donchian channel on M15
extern int timeframe15period=12;         // period of the donchian channel on M15
extern bool timeframe30=false;           // enable the donchian channel on M30
extern int timeframe30period=12;         // period of the donchian channel on M30
extern bool timeframe60=false;           // enable the donchian channel on H1
extern int timeframe60period=12;         // period of the donchian channel on H1
extern bool timeframe240=true;           // enable the donchian channel on H4
extern int timeframe240period=12;        // period of the donchian channel on H4
extern bool timeframe1440=true;          // enable the donchian channel on D1
extern int timeframe1440period=10;       // period of the donchian channel on D1
extern bool timeframe10080=false;        // enable the donchian channel on W1
extern int timeframe10080period=12;      // period of the donchian channel on W1

extern string timefilter="Time Filter";

extern int summergmtshift=2;             // gmt offset of the broker
extern int wintergmtshift=1;             // gmt offset of the broker
extern bool mondayfilter=true;          // enable special time filter on friday
extern int mondayhour=13;                // start to trade after this hour
extern int mondayminute=0;               // minutes of the friday hour
extern bool weekfilter=false;            // enable time filter
extern int starthour=7;                  // start hour to trade after this hour
extern int startminute=0;                // minutes of the start hour
extern int endhour=21;                   // stop to trade after this hour
extern int endminute=0;                  // minutes of the start hour
extern bool tradesunday=true;            // trade on sunday
extern bool fridayfilter=false;          // enable special time filter on friday
extern int fridayhour=12;                // stop to trade after this hour
extern int fridayminute=0;               // minutes of the friday hour
extern bool timeout=false;               // enable the time out
extern int closeafterminutes=60;         // close the order after 60 minutes

extern string volatilityfilters="Volatility Filter";

extern bool timeframe1vfilter=false;     // enable a volatility filter with bollinger band on M1
extern bool timeframe5vfilter=false;     // enable a volatility filter with bollinger band on M5
extern bool timeframe15vfilter=false;    // enable a volatility filter with bollinger band on M15
extern bool timeframe30vfilter=false;    // enable a volatility filter with bollinger band on M30
extern bool timeframe60vfilter=false;    // enable a volatility filter with bollinger band on H1
extern bool timeframe240vfilter=true;    // enable a volatility filter with bollinger band on H4
extern bool timeframe1440vfilter=true;   // enable a volatility filter with bollinger band on D1
extern bool timeframe10080vfilter=false; // enable a volatility filter with bollinger band on W1

extern string otherfilters="Other Filters";

extern bool demarkerreverse=false;
extern int demarkerperiod=14;
extern double demarkermax=0.7;
extern double demarkermin=0.3;
extern int demarkershift=1;
extern bool ccifilter=false;
extern int cciperiod=14;
extern int overbought=100;
extern int oversold=-100;
extern bool pricefilter=true;
extern bool patternsfilter=true;

datetime t0,t1,lastbuyopentime,lastsellopentime,tstart,tend,tfriday,tmonday;
double cb=0,lastbuyopenprice=0,lastsellopenprice=0;
double sl,tp,pt,mt,min,max,maxe,mine,win[14],sum[14];
int i,j,k,l,dg,bc=-1,tpb=0,total,ticket,gmtshift,nstarthour,nendhour,nfridayhour,nmondayhour;
string istarthour,istartminute,iendhour,iendminute,ifridayhour,ifridayminute,imondayhour,imondayminute;
int buyopenposition=0,sellopenposition=0;
int totalopenposition=0,buyorderprofit=0;
int sellorderprofit=0,cnt=0;

int init(){

   sum[2012-1999]=D'2012.03.28 02:00:00';win[2012-1999]=D'2012.10.31 03:00:00';
   sum[2011-1999]=D'2011.03.29 02:00:00';win[2011-1999]=D'2011.10.25 03:00:00';
   sum[2010-1999]=D'2010.03.30 02:00:00';win[2010-1999]=D'2010.10.26 03:00:00';
   sum[2009-1999]=D'2009.03.29 02:00:00';win[2009-1999]=D'2009.10.25 03:00:00';
   sum[2008-1999]=D'2008.03.30 02:00:00';win[2008-1999]=D'2008.10.26 03:00:00';
   sum[2007-1999]=D'2007.03.25 02:00:00';win[2007-1999]=D'2007.10.28 03:00:00';
   sum[2006-1999]=D'2006.03.26 02:00:00';win[2006-1999]=D'2006.10.29 03:00:00';
   sum[2005-1999]=D'2005.03.27 02:00:00';win[2005-1999]=D'2005.10.30 03:00:00';
   sum[2004-1999]=D'2004.03.28 02:00:00';win[2004-1999]=D'2004.10.31 03:00:00';
   sum[2003-1999]=D'2003.03.30 02:00:00';win[2003-1999]=D'2003.10.26 03:00:00';
   sum[2002-1999]=D'2002.03.31 02:00:00';win[2002-1999]=D'2002.10.27 03:00:00';
   sum[2001-1999]=D'2001.03.25 02:00:00';win[2001-1999]=D'2001.10.28 03:00:00';
   sum[2000-1999]=D'2000.03.26 02:00:00';win[2000-1999]=D'2000.10.29 03:00:00';
   sum[1999-1999]=D'1999.03.28 02:00:00';win[1999-1999]=D'1999.10.31 03:00:00';
   
   t0=Time[0];t1=Time[0];dg=Digits;
   if(dg==3 || dg==5){pt=Point*10;mt=10;}else{pt=Point;mt=1;}

   return(0);
}

int start(){

   /*if(fullcomment==false)Comment("\n  THE DONCHIAN SCALPER","\n   BY WWW.TRADINGSYSTEMFOREX.COM");*/
   
   if(fullcomment){
      //========Comment Start=======
      double free=AccountFreeMargin();
      Comment ("","\n","\n","\n","\n","\n",
      "\n","...................................... ",
      "\n",( "Current Open Trade Profit/Loss is : ",AccountProfit()), // What is our current profit/loss
      "\n","...................................... ",
      "\n",( "Account Curency:",AccountCurrency()),
      "\n", "Account free margin is ",DoubleToStr(free,2), // What is our freee margin
      "\n","...................................... ",
      "\n","High day price. ",MarketInfo(Symbol(),MODE_HIGH), // What was todays high
      "\n","Low day price.",MarketInfo(Symbol(),MODE_LOW), // What was todays low
      "\n","Currency Spread is ",MarketInfo(Symbol(),MODE_SPREAD),// What is current pip spread
      "\n","Current Ask Price is ",MarketInfo(Symbol(),MODE_ASK), // What is current Ask Price
      "\n","Current Bid Price is ",MarketInfo(Symbol(),MODE_BID),// What is current Bid Price
      "\n",( "Leverage 1:",AccountLeverage()),
      "\n","...................................... ",
      "\n",( "Account Balance:",AccountBalance()), // What is account Balance
      "\n","...................................... ",
      "\n" ,"Current Broker Time Is ",TimeToStr(TimeCurrent())); // What is broker time

      //....End Comment
   }
   
   if(showequityonchart){GlobalVariableSet("vGrafBalance",AccountBalance());
   GlobalVariableSet("vGrafEquity",AccountEquity());}
   
   total=OrdersTotal();
   
   if(breakevengain>0)
   {
      for(int b=0;b<total;b++){
         OrderSelect(b,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble((Bid-OrderOpenPrice()),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if(NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),dg)<NormalizeDouble(breakeven*pt,dg)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+breakeven*pt,dg),OrderTakeProfit(),0,Blue);
                     return(0);
                  }
               }
            }
            else{
               if(NormalizeDouble((OrderOpenPrice()-Ask),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if(NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),dg)<NormalizeDouble(breakeven*pt,dg)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-breakeven*pt,dg),OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
   if(trailingstop>0)
   {
      for(int a=0;a<total;a++){
         OrderSelect(a,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble(Ask,dg)>NormalizeDouble(OrderOpenPrice()+trailingstart*pt,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)<NormalizeDouble(Bid-(trailingstop+trailingstep)*pt,dg))||(OrderStopLoss()==0)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-trailingstop*pt,dg),OrderTakeProfit(),0,Blue);
                  return(0);
               }
            }
            else{
               if(NormalizeDouble(Bid,dg)<NormalizeDouble(OrderOpenPrice()-trailingstart*pt,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)>(NormalizeDouble(Ask+(trailingstop+trailingstep)*pt,dg)))||(OrderStopLoss()==0)){                 
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+trailingstop*pt,dg),OrderTakeProfit(),0,Red);
                  return(0);
               }
            }
         }
      }
   }
   if(basketpercent){
      double ipf=profit*(0.01*AccountBalance());double ilo=loss*(0.01*AccountBalance());
      cb=AccountEquity()-AccountBalance();
      if(cb>maxe)maxe=cb;if(cb<mine)mine=cb;
      if(cb>=ipf||cb<=(ilo*(-1))){
         for(i=total-1;i>=0;i--){
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY){
               OrderClose(OrderTicket(),OrderLots(),Bid,slippage*pt);
            }
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL){
               OrderClose(OrderTicket(),OrderLots(),Ask,slippage*pt);
            }
         }
         return(0);
      }
   }
   
   for(cnt=0;cnt<OrdersTotal();cnt++){
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==magic&&OrderCloseTime()==0){
         totalopenposition++;
         if(OrderType()==OP_BUY){
            buyopenposition++;lastbuyopenprice=OrderOpenPrice();buyorderprofit=OrderProfit();lastbuyopentime=OrderOpenTime();
         }
         if(OrderType()==OP_SELL){
            sellopenposition++;lastsellopenprice=OrderOpenPrice();sellorderprofit=OrderProfit();lastsellopentime=OrderOpenTime();
         }
      }
   }
   
   double DU1a=iHigh(Symbol(),1,iHighest(Symbol(),1,MODE_HIGH,timeframe1period,shift+1));
   double DD1a=iLow(Symbol(),1,iLowest(Symbol(),1,MODE_LOW,timeframe1period,shift+1));
   double DU1=iHigh(Symbol(),1,iHighest(Symbol(),1,MODE_HIGH,timeframe1period,shift));
   double DD1=iLow(Symbol(),1,iLowest(Symbol(),1,MODE_LOW,timeframe1period,shift));
   
   double DU5a=iHigh(Symbol(),5,iHighest(Symbol(),5,MODE_HIGH,timeframe5period,shift+1));
   double DD5a=iLow(Symbol(),5,iLowest(Symbol(),5,MODE_LOW,timeframe5period,shift+1));
   double DU5=iHigh(Symbol(),5,iHighest(Symbol(),5,MODE_HIGH,timeframe5period,shift));
   double DD5=iLow(Symbol(),5,iLowest(Symbol(),5,MODE_LOW,timeframe5period,shift));
   
   double DU15a=iHigh(Symbol(),15,iHighest(Symbol(),15,MODE_HIGH,timeframe15period,shift+1));
   double DD15a=iLow(Symbol(),15,iLowest(Symbol(),15,MODE_LOW,timeframe15period,shift+1));
   double DU15=iHigh(Symbol(),15,iHighest(Symbol(),15,MODE_HIGH,timeframe15period,shift));
   double DD15=iLow(Symbol(),15,iLowest(Symbol(),15,MODE_LOW,timeframe15period,shift));
   
   double DU30a=iHigh(Symbol(),30,iHighest(Symbol(),30,MODE_HIGH,timeframe30period,shift+1));
   double DD30a=iLow(Symbol(),30,iLowest(Symbol(),30,MODE_LOW,timeframe30period,shift+1));
   double DU30=iHigh(Symbol(),30,iHighest(Symbol(),30,MODE_HIGH,timeframe30period,shift));
   double DD30=iLow(Symbol(),30,iLowest(Symbol(),30,MODE_LOW,timeframe30period,shift));
   
   double DU60a=iHigh(Symbol(),60,iHighest(Symbol(),60,MODE_HIGH,timeframe60period,shift+1));
   double DD60a=iLow(Symbol(),60,iLowest(Symbol(),60,MODE_LOW,timeframe60period,shift+1));
   double DU60=iHigh(Symbol(),60,iHighest(Symbol(),60,MODE_HIGH,timeframe60period,shift));
   double DD60=iLow(Symbol(),60,iLowest(Symbol(),60,MODE_LOW,timeframe60period,shift));
   
   double DU240a=iHigh(Symbol(),240,iHighest(Symbol(),240,MODE_HIGH,timeframe240period,shift+1));
   double DD240a=iLow(Symbol(),240,iLowest(Symbol(),240,MODE_LOW,timeframe240period,shift+1));
   double DU240=iHigh(Symbol(),240,iHighest(Symbol(),240,MODE_HIGH,timeframe240period,shift));
   double DD240=iLow(Symbol(),240,iLowest(Symbol(),240,MODE_LOW,timeframe240period,shift));
   
   double DU1440a=iHigh(Symbol(),1440,iHighest(Symbol(),1440,MODE_HIGH,timeframe1440period,shift+1));
   double DD1440a=iLow(Symbol(),1440,iLowest(Symbol(),1440,MODE_LOW,timeframe1440period,shift+1));
   double DU1440=iHigh(Symbol(),1440,iHighest(Symbol(),1440,MODE_HIGH,timeframe1440period,shift));
   double DD1440=iLow(Symbol(),1440,iLowest(Symbol(),1440,MODE_LOW,timeframe1440period,shift));
   
   double DU10080a=iHigh(Symbol(),10080,iHighest(Symbol(),10080,MODE_HIGH,timeframe10080period,shift+1));
   double DD10080a=iLow(Symbol(),10080,iLowest(Symbol(),10080,MODE_LOW,timeframe10080period,shift+1));
   double DU10080=iHigh(Symbol(),10080,iHighest(Symbol(),10080,MODE_HIGH,timeframe10080period,shift));
   double DD10080=iLow(Symbol(),10080,iLowest(Symbol(),10080,MODE_LOW,timeframe10080period,shift));

   bool openbuy=true;bool opensell=true;
   bool closebuy=false;bool closesell=false;

   if((timeframe1vfilter && iBands(NULL,1,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,1,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,1,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,1,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1))
   ||(timeframe5vfilter && iBands(NULL,5,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,5,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,5,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,5,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1))
   ||(timeframe15vfilter && iBands(NULL,15,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,15,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,15,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,15,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1))
   ||(timeframe30vfilter && iBands(NULL,30,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,30,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,30,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,30,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1))
   ||(timeframe60vfilter && iBands(NULL,60,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,60,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,60,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,15,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1))
   ||(timeframe240vfilter && iBands(NULL,240,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,240,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,240,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,240,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1))
   ||(timeframe1440vfilter && iBands(NULL,1440,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,1440,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,1440,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,1440,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1))
   ||(timeframe10080vfilter && iBands(NULL,10080,20,2,0,PRICE_CLOSE,MODE_LOWER,shift)>iBands(NULL,10080,20,2,0,PRICE_CLOSE,MODE_LOWER,shift+1)
   && iBands(NULL,10080,20,2,0,PRICE_CLOSE,MODE_UPPER,shift)<iBands(NULL,10080,20,2,0,PRICE_CLOSE,MODE_UPPER,shift+1)))
   {openbuy=false;opensell=false;}
   
   double c1m5=Close[1];double x5=5*pt;double x10=10*pt;double x50=50*pt;double x110=110*pt;double c1=iClose(NULL,60,1);
   double c2=iClose(NULL,60,2);double c3=iClose(NULL,60,3);double c4=iClose(NULL,60,4);double c5=iClose(NULL,60,5);double c6=iClose(NULL,60,6);
   double c7=iClose(NULL,60,7);double c8=iClose(NULL,60,8);double c9=iClose(NULL,60,9);double c10=iClose(NULL,60,10);double c11=iClose(NULL,60,11);
   double c12=iClose(NULL,60,12);double c13=iClose(NULL,60,13);double o1=iOpen(NULL,60,1);double o2=iOpen(NULL,60,2);double o3=iOpen(NULL,60,3);
   double o4=iOpen(NULL,60,4);double o5=iOpen(NULL,60,5);double o6=iOpen(NULL,60,6);double o7=iOpen(NULL,60,7);double o8=iOpen(NULL,60,8);
   double o9=iOpen(NULL,60,9);double o10=iOpen(NULL,60,10);double o11=iOpen(NULL,60,11);double o12=iOpen(NULL,60,12);double o13=iOpen(NULL,60,13);
   double h1=iHigh(NULL,60,1);double h2=iHigh(NULL,60,2);double h3=iHigh(NULL,60,3);double h4=iHigh(NULL,60,4);double h5=iHigh(NULL,60,5);
   double h6=iHigh(NULL,60,6);double h7=iHigh(NULL,60,7);double h8=iHigh(NULL,60,8);double h9=iHigh(NULL,60,9);double h10=iHigh(NULL,60,10);
   double h11=iHigh(NULL,60,11);double h12=iHigh(NULL,60,12);double h13=iHigh(NULL,60,13);double l1=iLow(NULL,60,1);double l2=iLow(NULL,60,2);
   double l3=iLow(NULL,60,3);double l4=iLow(NULL,60,4);double l5=iLow(NULL,60,5);double l6=iLow(NULL,60,6);double l7=iLow(NULL,60,7);
   double l8=iLow(NULL,60,8);double l9=iLow(NULL,60,9);double l10=iLow(NULL,60,10);double l11=iLow(NULL,60,11);double l12=iLow(NULL,60,12);
   double l13=iLow(NULL,60,13);

   if((pricefilter && c1m5>(c6+110*pt))
   ||(patternsfilter && (
   (c1>=c2 && c1>=c3 && o4>c4 && c5>o5 && (o4-c4)>=50*pt && (o5-l5)<=5*pt && (h4-o4)<=5*pt) || (c6>o6 && c5>o5 && c4>o4 && c3>o3 && c2>o2 && c1>o1
   && (c6-o6)<(c5-o5) && (c5-o5)<(c4-o4) && (c4-o4)>(c3-o3) && (c3-o3)<(c2-o2)&& (c2-o2)<(c1-o1) && (c3-o3)<4*(h3-c3) && (c2-o2)<2*(h2-c2) && h1<h2)
   || (c5>o5 && c4>o4 && c3>o3 && c2>o2 && c1>o1 && (c5-o5)<(c4-o4) && (c4-o4)<(c3-o3)&& (c3-o3)>(c2-o2) && (c2-o2)<(c1-o1) && (c2-o2)<10*(h2-c2)
   && (c1-o1)<2*(h1-c1)) || (c5>o5 && c4>o4 && c3>o3 && c2>o2 && c1<o1 && (c5-o5)>110*pt && (c5-o5)>(c4-o4) && (c4-o4)>=(c3-o3) && (c3-o3)<(c2-o2)
   && h5>h4 && h5>h3 && h5>h2 && h5>h1 && h2>h1 && l5<h4 && l4<h3 && l3<h2 && l1<h2) || (c3>o3 && c2>o2 && c1>o1 && (c3-o3)<=10*pt && (c2-o2)>=50*pt
   && h3<h2 && h2<h1 && (o3-l3)<=5*pt && (o2-l2)<=5*pt && (o1-l1)<=5*pt) || (c4>o4 && c3>o3 && c2>o2 && (c4-o4)<=10*pt && (c3-o3)>=50*pt && h4<h3
   && h3<h2 && (o4-l4)<=5*pt && (o3-l3)<=5*pt && (o2-l2)<=5*pt && h1<h2) || (c5>o5 && c4>o4 && c3>o3 && (c5-o5)<=10*pt && (c4-o4)>=50*pt && h5<h4
   && h4<h3 && (o5-l5)<=5*pt && (o4-l4)<=5*pt && (o3-l3)<=5*pt && h2<h3 && h1<h2) || (c6>o6 && c5>o5 && c4>o4 && (c6-o6)<=10*pt && (c5-o5)>=50*pt
   && h6<h5 && h5<h4 && (o6-l6)<=5*pt && (o5-l5)<=5*pt && (o4-l4)<=5*pt && h3<h4 && h2<h3 && h1<h2) || (c7>o7 && c6>o6 && c5>o5 && (c7-o7)<=10*pt
   && (c6-o6)>=50*pt && h7<h6 && h6<h5 && (o7-l7)<=5*pt && (o6-l6)<=5*pt && (o5-l5)<=5*pt && h4<h5 && h3<h4 && h2<h3 && h1<h2) || (c8>o8 && c7<o7
   && c6>o6 && c5<o5 && c4>o4 && c3>o3 && c2>=o2 && c1<o1 && l8<l7 && l7<l6 && l6<l5 && l5<l4 && l4<l3 && l3<l2 && l2>l1 && h8<=h7 && h7<h6 && h6>h5
   && h5<h4 && h4<h3 && h3<h2 && h2>h1) || (c7>o7 && c6<o6 && c5>o5 && c4<o4 && c3>o3 && c2>o2 && c1<o1 && h7>h6 && h6<h5 && h5>h4 && h4<h3 && h3<h2
   && h2>h1 && l7>l6 && l6<l5 && l5>l4 && l4<l3 && l3<l2 && l2<l1) || (c8>o8 && c7<o7 && c6>o6 && c5<o5 && c4>o4 && c3>o3 && c2<o2 && h8>h7 && h7<h6
   && h6>h5 && h5<h4 && h4<h3 && h3>h2 && l8>l7 && l7<l6 && l6>l5 && l5<l4 && l4<l3 && l3<l2) || (c9>o9 && c8<o8 && c7>o7 && c6<o6 && c5>o5 && c4>o4
   && c3<o3 && h9>h8 && h8<h7 && h7>h6 && h6<h5 && h5<h4 && h4>h3 && l9>l8 && l8<l7 && l7>l6 && l6<l5 && l5<l4 && l4<l3) || (c10>o10 && c9<o9 && c8>o8
   && c7<o7 && c6>o6 && c5>o5 && c4<o4 && h10>h9 && h9<h8 && h8>h7 && h7<h6 && h6<h5 && h5>h4 && l10>l9 && l9<l8 && l8>l7 && l7<l6 && l6<l5 && l5<l4)
   || (c7<o7 && c6<o6 && c5>o5 && c4>o4 && o3>c3 && o2>c2 && c1>o1 && h7<h6 && h6>h5 && h5<h4 && h4>h3 && h3>h2 && h2>=h1 && l7>l6 && l6>l5 && l5<l4
   && l4>l3 && l3>l2 && l2<l1 && (c7-l7)<=5*pt && (c6-l6)<=5*pt && (h3-o3)<=5*pt && (h2-o2)<=5*pt && (h1-c1)<=5*pt) || (c8<o8 && c7<o7 && c6>o6 && c5>o5
   && o4>c4 && o3>c3 && c2>o2 && h8<h7 && h7>h6 && h6<h5 && h5>h4 && h4>h3 && h3>=h2 && l8>l7 && l7>l6 && l6<l5 && l5>l4 && l4>l3 && l3<l2 && (c8-l8)<=5*pt
   && (c7-l7)<=5*pt && (h4-o4)<=5*pt && (h3-o3)<=5*pt && (h2-c2)<=5*pt) || (c9<o9 && c8<o8 && c7>o7 && c6>o6 && o5>c5 && o4>c4 && c3>o3 && h9<h8
   && h8>h7 && h7<h6 && h6>h5 && h5>h4 && h4>=h3 && l9>l8 && l8>l7 && l7<l6 && l6>l5 && l5>l4 && l4<l3 && (c9-l9)<=5*pt && (c8-l8)<=5*pt && (h5-o5)<=5*pt 
   && (h4-o4)<=5*pt && (h3-c3)<=5*pt) || (c10<o10 && c9<o9 && c8>o8 && c7>o7 && o6>c6 && o5>c5 && c4>o4 && h10<h9 && h9>h8 && h8<h7 && h7>h6 && h6>h5
   && h5>=h4 && l10>l9 && l9>l8 && l8<l7 && l7>l6 && l6>l5 && l5<l4 && (c10-l10)<=5*pt && (c9-l9)<=5*pt && (h6-o6)<=5*pt && (h5-o5)<=5*pt && (h4-c4)<=5*pt)
   || (c10>o10 && o9>c9 && c8>o8 && c7>o7 && c6>o6 && c5>o5 && c4>o4 && c3<o3 && c2>o2 && c1>o1 && h10<h9 && h9>h8 && h8<h7 && h7<h6 && h6<h5 && h5<h4
   && h4<h3 && h3<h2 && h2<h1 && l10>l9 && l9<l8 && l8<l7 && l7<l6 && l6<l5 && l5<l4 && l4<l3 && l3>l2 && l2<l1) || (c9<o9 && c8>=o8 && c7<o7 && c6>o6
   && c5>o5 && c4>o4 && c3<o3 && c2>o2 && c1>o1 && h9<h8 && h8<h7 && h7<h6 && h6<h5 && h5<h4 && h4<h3 && h3>h2 && h2<h1 && l9<l8 && l8>l7 && l7>l6
   && l6<l5 && l5<l4 && l4<l3 && l3<=l2 && l2<l1) || (c10<o10 && c9>=o9 && c8<o8 && c7>o7 && c6>o6 && c5>o5 && c4<o4 && c3>o3 && c2>o2 && h10<h9
   && h9<h8 && h8<h7 && h7<h6 && h6<h5 && h5<h4 && h4>h3 && h3<h2 && l10<l9 && l9>l8 && l8>l7 && l7<l6 && l6<l5 && l5<l4 && l4<=l3 && l3<l2) || (c10>o10
   && c9>o9 && c8<o8 && c7>o7 && c6>o6 && c5>o5 && c4>o4 && c3>o3 && c2<o2 && c1<o1 && h10<h9 && h9>h8 && h8>h7 && h7<h6 && h6>h5 && h5<h4 && h4<h3
   && h3>h2 && h2>h1 && l10<l9 && l9>l8 && l8>l7 && l7<l6 && l6<l5 && l5<l4 && l4<l3 && l3>l2 && l2>l1) || (c9>=c9 && c8<o8 && c7<o7 && c6<o6 && c5<o5
   && c4>o4 && c3>o3 && c2<o2 && c1>o1 && h9>h8 && h8>=h7 && h7>h6 && h6>h5 && h5>h4 && h4<h3 && h3>h2 && h2<h1 && l9>l8 && l8>l7 && l7>l6 && l6<l5
   && l5<l4 && l4<l3 && l3<l2 && l2<l1) || (c10>=c10 && c9<o9 && c8<o8 && c7<o7 && c6<o6 && c5>o5 && c4>o4 && c3<o3 && c2>o2 && h10>h9 && h9>=h8
   && h8>h7 && h7>h6 && h6>h5 && h5<h4 && h4>h3 && h3<h2 && l10>l9 && l9>l8 && l8>l7 && l7<l6 && l6<l5 && l5<l4 && l4<l3 && l3<l2) || (c9>o9 && c8>=o8
   && c7>o7 && c6>o6 && c5>o5 && c4>o4 && c3<o3 && c2<o2 && c1>o1 && h9>=h8 && h8<h7 && h7>h6 && h6<h5 && h5<h4 && h4<h3 && h3>h2 && h2>=h1 && l9<l8
   && l8<=l7 && l7<l6 && l6<l5 && l5<=l4 && l4<l3 && l3>l2 && l2<l1) || (c10>o10 && c9>=o9 && c8>o8 && c7>o7 && c6>o6 && c5>o5 && c4<o4 && c3<o3
   && c2>o2 && h10>=h9 && h9<h8 && h8>h7 && h7<h6 && h6<h5 && h5<h4 && h4>h3 && h3>=h2 && l10<l9 && l9<=l8 && l8<l7 && l7<l6 && l6<=l5 && l5<l4
   && l4>l3 && l3<l2) || (c9>o9 && c8>o8 && c7>o7 && c6<o6 && c5>o5 && c4>o4 && c3<o3 && c2>o2 && c1>o1 && h9<h8 && h8<h7 && h7>h6 && h6>h5 && h5<h4
   && h4<h3 && h3>h2 && h2<h1 && l9<l8 && l8<l7 && l7<=l6 && l6>l5 && l5<l4 && l4<l3 && l3>l2 && l2<l1) || (c10>o10 && c9>o9 && c8>o8 && c7<o7 && c6>o6
   && c5>o5 && c4<o4 && c3>o3 && c2>o2 && h10<h9 && h9<h8 && h8>h7 && h7>h6 && h6<h5 && h5<h4 && h4>h3 && h3<h2 && l10<l9 && l9<l8 && l8<=l7 && l7>l6
   && l6<l5 && l5<l4 && l4>l3 && l3<l2) || (c9>o9 && c8>o8 && c7<o7 && c6>o6 && c5>o5 && c4>o4 && c3<o3 && c2>o2 && c1>o1 && h9<h8 && h8>h7 && h7>h6
   && h6<h5 && h5<h4 && h4>h3 && h3<h2 && h2>h1 && l9<l8 && l8>l7 && l7>l6 && l6<l5 && l5<l4 && l4<l3 && l3<l2 && l2<l1) || (c10>o10 && c9>o9 && c8<o8
   && c7>o7 && c6>o6 && c5>o5 && c4<o4 && c3>o3 && c2>o2 && h10<h9 && h9>h8 && h8>h7 && h7<h6 && h6<h5 && h5>h4 && h4<h3 && h3>h2 && l10<l9 && l9>l8
   && l8>l7 && l7<l6 && l6<l5 && l5<l4 && l4<l3 && l3<l2) || (c9>o9 && c8<o8 && c7<o7 && c6>o6 && c5<o5 && c4<o4 && c3>o3 && c2>o2 && c1<o1 && h9>h8
   && h8>h7 && h7>=h6 && h6>=h5 && h5>=h4 && h4<h3 && h3<h2 && h2>h1 && l9<l8 && l8>l7 && l7<l6 && l6<l5 && l5>l4 && l4<l3 && l3<l2 && l2>l1) || (c9<o9
   && c8>o8 && c7>o7 && c6>=o6 && c5>o5 && c4>o4 && c3<o3 && c2>o2 && c1>o1 && h9<h8 && h8<h7 && h7<h6 && h6<=h5 && h5<h4 && h4>h3 && h3>h2 && h2<h1
   && l9<l8 && l8<l7 && l7<l6 && l6<l5 && l5<l4 && l4<l3 && l3>l2 && l2<l1)
   )))openbuy=false;
   
   if((pricefilter && c1m5<(c6-110*pt))
   || (patternsfilter && (
   (c5>o5 && c4>o4 && c3>o3 && c2<o2 && c1>o1 && (c5-o5)>(c4-o4) && (c4-o4)>(c3-o3) && (c3-o3)>(o2-c2) && (o2-c2)<(c1-o1)) ||(c6>o6 && c5>o5 && c4>o4
   && c3<o3 && c2>o2 && c1>o1 && (c6-o6)>(c5-o5) && (c5-o5)>(c4-o4) && (c4-o4)>(o3-c3) && (o3-c3)<(c2-o2) && (c2-o2)<=(c1-o1)) || (c9<o9 && c8<o8
   && c7>o7 && c6<=o6 && c5<o5 && c4<o4 && c3>o3 && c2<o2 && c1<o1 && h9>h8 && h8<h7 && h7>h6 && h6>h5 && h5>h4 && h4>h3 && h3<h2 && h2>h1 &&l9>l8
   && l8<l7 && l7<l6 && l6<=l5 && l5>l4 && l4>l3 && l3<l2 && l2>l1) || (c10<o10 && c9<o9 && c8>o8 && c7<=o7 && c6<o6 && c5<o5 && c4>o4 && c3<o3
   && c2<o2 && h10>h9 && h9<h8 && h8>h7 && h7>h6 && h6>h5 && h5>h4 && h4<h3 && h3>h2 && l10>l9 && l9<l8 && l8<l7 && l7<=l6 && l6>l5 && l5>l4 && l4<l3
   && l3>l2) || (c11<o11 && c10<o10 && c9>o9 && c8<=o8 && c7<o7 && c6<o6 && c5>o5 && c4<o4 && c3<o3 && h11>h10 && h10<h9 && h9>h8 && h8>h7 && h7>h6
   && h6>h5 && h5<h4 && h4>h3 && l11>l10 && l10<l9 && l9<l8 && l8<=l7 && l7>l6 && l6>l5 && l5<l4 && l4>l3) || (c12<o12 && c11<o11 && c10>o10 && c9<=o9
   && c8<o8 && c7<o7 && c6>o6 && c5<o5 && c4<o4 && h12>h11 && h11<h10 && h10>h9 && h9>h8 && h8>h7 && h7>h6 && h6<h5 && h5>h4 && l12>l11 && l11<l10
   && l10<l9 && l9<=l8 && l8>l7 && l7>l6 && l6<l5 && l5>l4) || (c13<o13 && c12<o12 && c11>o11 && c10<=o10 && c9<o9 && c8<o8 && c7>o7 && c6<o6 && c5<o5
   && h13>h12 && h12<h11 && h11>h10 && h10>h9 && h9>h8 && h8>h7 && h7<h6 && h6>h5 && l13>l12 && l12<l11 && l11<l10 && l10<=l9 && l9>l8 && l8>l7
   && l7<l6 && l6>l5) || (c9>o9 && c8>o8 && c7<=o7 && c6>o6 && c5<o5 && c4>o4 && c3>=o3 && c2<o2 && c1<o1 && h9>=h8 && h8<=h7 && h7<h6 && h6>h5
   && h5>h4 && h4>h3 && h3>h2 && h2>h1 && l9<=l8 && l8>l7 && l7<l6 && l6<l5 && l5<=l4 && l4<l3 && l3>l2 && l2<=l1) || (c9>=o9 && c8<o8 && c7<o7
   && c6<o6 && c5<o5 && c4>o4 && c3>o3 && c2<o2 && c1>o1 && h9>h8 && h8>=h7 && h7>h6 && h6>h5 && h5>h4 && h4<h3 && h3>h2 && h2<h1 && l9>l8 && l8>l7
   && l7>l6 && l6>l5 && l5<l4 && l4<l3 && l3<l2 && l2<l1) || (c10>=o10 && c9<o9 && c8<o8 && c7<o7 && c6<o6 && c5>o5 && c4>o4 && c3<o3 && c2>o2
   && h10>h9 && h9>=h8 && h8>h7 && h7>h6 && h6>h5 && h5<h4 && h4>h3 && h3<h2 && l10>l9 && l9>l8 && l8>l7 && l7>l6 && l6<l5 && l5<l4 && l4<l3 && l3<l2)
   || (c9<o9 && c8>o8 && c7<o7 && c6<o6 && c5>o5 && c4<o4 && c3<o3 && c2<o2 && c1<o1 && h9>h8 && h8<h7 && h7>h6 && h6<h5 && h5>h4 && h4>h3 && h3>h2
   && h2>h1 && l9<l8 && l8<l7 && l7>l6 && l6>l5 && l5<l4 && l4>l3 && l3>l2 && l2>l1) || (c10<o10 && c9>o9 && c8<o8 && c7<o7 && c6>o6 && c5<o5
   && c4<o4 && c3<o3 && c2<o2 && h10>h9 && h9<h8 && h8>h7 && h7<h6 && h6>h5 && h5>h4 && h4>h3 && h3>h2 && l10<l9 && l9<l8 && l8>l7 && l7>l6
   && l6<l5 && l5>l4 && l4>l3 && l3>l2) || (c9>o9 && c8<o9 && c7<o7 && c6<o6 && c5<o5 && c4>o4 && c3>o3 && c2<o2 && c1>=o1 && h10>h9 && h9>h8
   && h8>h7 && h7>h6 && h6>h5 && h5>h4 && h4<h3 && h3<h2 && h2<h1 && l9<l8 && l8>l7 && l7>l6 && l6>l5 && l5>=l4 && l4>=l3 && l3<l2 && l2<=l1)
   || (c9>o9 && c8>o8 && c7<o7 && c6>=o6 && c5>o5 && c4<o4 && c3>o3 && c2<o2 && c1>o1 && h9<h8 && h8<h7 && h7<h6 && h6<h5 && h5<h4 && h4>h3 && h3<h2
   && h2>h1 && l9<=l8 && l8<l7 && l7<=l6 && l6>l5 && l5>l4 && l4<l3 && l3>l2 && l2>l1) || (c10>o10 && c9>o9 && c8<o8 && c7>=o7 && c6>o6 && c5<o5
   && c4>o4 && c3<o3 && c2>o2 && h10<h9 && h9<h8 && h8<h7 && h7<h6 && h6<h5 && h5>h4 && h4<h3 && h3>h2 && l10<=l9 && l9<l8 && l8<=l7 && l7>l6
   && l6>l5 && l5<l4 && l4>l3 && l3>l2) || (c11>o11 && c10>o10 && c9<o9 && c8>=o8 && c7>o7 && c6<o6 && c5>o5 && c4<o4 && c3>o3 && h11<h10 && h10<h9
   && h9<h8 && h8<h7 && h7<h6 && h6>h5 && h5<h4 && h4>h3 && l11<=l10 && l10<l9 && l9<=l8 && l8>l7 && l7>l6 && l6<l5 && l5>l4 && l4>l3) || (c12>o12
   && c11>o11 && c10<o10 && c9>=o9 && c8>o8 && c7<o7 && c6>o6 && c5<o5 && c4>o4 && h12<h11 && h11<h10 && h10<h9 && h9<h8 && h8<h7 && h7>h6 && h6<h5
   && h5>h4 && l12<=l11 && l11<l10 && l10<=l9 && l9>l8 && l8>l7 && l7<l6 && l6>l5 && l5>l4) || (c9<o9 && c8>o8 && c7<o7 && c6>=o6 && c5<o5 && c4>o4
   && c3<o3 && c2<o2 && c1>o1 && h9>h8 && h8>h7 && h7>h6 && h6<h5 && h5<=h4 && h4<=h3 && h3>h2 && h2>h1 && l9<l8 && l8<l7 && l7>l6 && l6>l5
   && l5<l4 && l4>l3 && l3>l2 && l2<l1) || (c9<o9 && c8>=o8 && c7<o7 && c6>o6 && c5<o5 && c4<o4 && c3>o3 && c2>o2 && c1>o1 && h9>h8 && h8<h7
   && h7<=h6 && h6<=h5 && h5>h4 && h4>h3 && h3<h2 && h2<h1 && l9>=l8 && l8>=l7 && l7<l6 && l6>l5 && l5>l4 && l4<l3 && l3<l2 && l2<l1) || (c10<o10
   && c9>=o9 && c8<o8 && c7>o7 && c6<o6 && c5<o5 && c4>o4 && c3>o3 && c2>o2 && h10>h9 && h9<h8 && h8<=h7 && h7<=h6 && h6>h5 && h5>h4 && h4<h3
   && h3<h2 && l10>=l9 && l9>=l8 && l8<l7 && l7>l6 && l6>l5 && l5<l4 && l4<l3 && l3<l2) || (c9>o9 && c8<o8 && c7>o7 && c6<o6 && c5>=o5 && c4<o4
   && c3<o3 && c2<o2 && c1>o1 && h9>h8 && h8>h7 && h7>h6 && h6>h5 && h5>h4 && h4>h3 && h3>h2 && h2>h1 && l9>l8 && l8<=l7 && l7>l6 && l6>l5 && l5>l4
   && l4>l3 && l3>l2 && l2<l1) || (c10>o10 && c9<o9 && c8>o8 && c7<o7 && c6>=o6 && c5<o5 && c4<o4 && c3<o3 && c2>o2 && h10>h9 && h9>h8 && h8>h7
   && h7>h6 && h6>h5 && h5>h4 && h4>h3 && h3>h2 && l10>l9 && l9<=l8 && l8>l7 && l7>l6 && l6>l5 && l5>l4 && l4>l3 && l3<l2) || (c11>o11 && c10<o10
   && c9>o9 && c8<o8 && c7>=o7 && c6<o6 && c5<o5 && c4<o4 && c3>o3 && h11>h10 && h10>h9 && h9>h8 && h8>h7 && h7>h6 && h6>h5 && h5>h4 && h4>h3
   && l11>l10 && l10<=l9 && l9>l8 && l8>l7 && l7>l6 && l6>l5 && l5>l4 && l4<l3) || (c12>o12 && c11<o11 && c10>o10 && c9<o9 && c8>=o8 && c7<o7
   && c6<o6 && c5<o5 && c4>o4 && h12>h11 && h11>h10 && h10>h9 && h9>h8 && h8>h7 && h7>h6 && h6>h5 && h5>h4 && l12>l11 && l11<=l10 && l10>l9
   && l9>l8 && l8>l7 && l7>l6 && l6>l5 && l5<l4) ||(c9>o9 && c8>o8 && c7<o7 && c6>o6 && c5>o5 && c4<=o4 && c3<o3 && c2<o2 && c1>o1 && h9<h8
   && h8<=h7 && h6<h5 && h5<h4 && h4>h3 && h3>h2 && h2>h1 && l9<l8 && l8>l7 && l7<l6 && l6<=l5 && l5<l4 && l4>l3 && l3>l2 &&l2<l1) || (c9>o9
   && c8<o8 && c7>o7 && c6>o6 && c5>o5 && c4<o4 && c3<o3 && c2<o2 && c1>o1 && h9<h8 && h8>h7 && h7<h6 && h6<h5 && h5>=h4 && h4>h3 && h3>h2 && h2>h1
   && l9<l8 && l8>l7 && l7<=l6 && l6<l5 && l5>l4 && l4>l3 && l3>=l2 && l2>l1) || (c10>o10 && c9<o9 && c8>o8 && c7>o7 && c6>o6 && c5<o5 && c4<o4
   && c3<o3 && c2>o2 && h10<h9 && h9>h8 && h8<h7 && h7<h6 && h6>=h5 && h5>h4 && h4>h3 && h3>h2 && l10<l9 && l9>l8 && l8<=l7 && l7<l6 && l6>l5
   && l5>l4 && l4>=l3 && l3>l2) || (c11>o11 && c10<o10 && c9>o9 && c8>o8 && c7>o7 && c6<o6 && c5<o5 && c4<o4 && c3>o3 && h11<h10 && h10>h9 && h9<h8
   && h8<h7 && h7>=h6 && h6>h5 && h5>h4 && h4>h3 && l11<l10 && l10>l9 && l9<=l8 && l8<l7 && l7>l6 && l6>l5 && l5>=l4 && l4>l3) || (c12>o12 && c11<o11
   && c10>o10 && c9>o9 && c8>o8 && c7<o7 && c6<o6 && c5<o5 && c4>o4 && h12<h11 && h11>h10 && h10<h9 && h9<h8 && h8>=h7 && h7>h6 && h6>h5 && h5>h4
   && l12<l11 && l11>l10 && l10<=l9 && l9<l8 && l8>l7 && l7>l6 && l6>=l5 && l5>l4) || (c9>o9 && c8<o8 && c7>=o7 && c6<o6 && c5<o5 && c4>=o4 && c3>o3
   && c2<o2 && c1<o1 && h9>h8 && h8>=h7 && h7>=h6 && h6>h5 && h5>h4 && h4<h3 && h3>h2 && h2>h1 && l9>l8 && l8<l7 && l7>l6 && l6>l5 && l5>l4 && l4<l3
   && l3<l2 && l2>l1) || (c10>o10 && c9<o9 && c8>=o8 && c7<o7 && c6<o6 && c5>=o5 && c4>o4 && c3<o3 && c2<o2 && h10>h9 && h9>=h8 && h8>=h7 && h7>h6
   && h6>h5 && h5<h4 && h4>h3 && h3>h2 && l10>l9 && l9<l8 && l8>l7 && l7>l6 && l6>l5 && l5<l4 && l4<l3 && l3>l2) || (c9<o9 && c8<o8 && c7<o7 && c6>o6
   && c5<o5 && c4<o4 && c3>o3 && c2>o2 && c1<o1 && h9>h8 && h8>h7 && h7>=h6 && h6<h5 && h5>h4 && h4>h3 && h3>=h2 && h2>h1 && l9>l8 && l8>l7 && l7>l6
   && l6<l5 && l5>l4 && l4<l3 && l3>l2 && l2>l1) || (c9<o9 && c8>o8 && c7<o7 && c6>o6 && c5<o5 && c4<o4 && c3>o3 && c2>o2 && c1<o1 && h9<h8 && h8>h7
   && h7>h6 && h6<h5 && h5>h4 && h4<h3 && h3<h2 && h2>h1 && l9<l8 && l8>l7 && l7<l6 && l6>l5 && l5>l4 && l4>l3 && l3<l2 && l2>l1) || (c9>o9 && c8>o8
   && c7<o7 && c6<o6 && c5<o5 && c4>o4 && c3>o3 && c2>o2 && c1<=o1 && h9<h8 && h8<h7 && h7<h6 && h6>h5 && h5>=h4 && h4<h3 && h3<h2 && h2>h1 && l9<l8
   && l8<l7 && l7>l6 && l6>l5 && l5>l4 && l4<l3 && l3<l2 && l2>l1) || (c9>o9 && c8<o8 && c7<o7 && c6<o6 && c5<o5 && c4>o4 && c3>o3 && c2<o2 && c1>=o1
   && h9>h8 && h8>h7 && h7>h6 && h6>h5 && h5>h4 && h4<h3 && h3<h2 && h2<h1 && l9<l8 && l8>l7 && l7>l6 && l6>l5 && l5>=l4 && l4>=l3 && l3<l2 && l2<=l1)
    || (c9<o9 && c8<o8 && c7<=o7 && c6<=o6 && c5>=o5 && c4>o4 && c3>o3 && c2<o2 && c1>o1 && h9>h8 && h8>h7 && h7<h6 && h6>h5 && h5<h4 && h4<h3 && h3>h2
    && h2<h1 && l9>l8 && l8>l7 && l7<l6 && l6>l5 && l5<l4 && l4<l3 && l3>l2 && l2<l1) || (c10<o10 && c9<o9 && c8<=o8 && c7<=o7 && c6>=o6 && c5>o5
    && c4>o4 && c3<o3 && c2>o2 && h10>h9 && h9>h8 && h8<h7 && h7>h6 && h6<h5 && h5<h4 && h4>h3 && h3<h2 && l10>l9 && l9>l8 && l8<l7 && l7>l6 && l6<l5
    && l5<l4 && l4>l3 && l3<l2) || (c11<o11 && c10<o10 && c9<=o9 && c8<=o8 && c7>=o7 && c6>o6 && c5>o5 && c4<o4 && c3>o3 && h11>h10 && h10>h9 && h9<h8
    && h8>h7 && h7<h6 && h6<h5 && h5>h4 && h4<h3 && l11>l10 && l10>l9 && l9<l8 && l8>l7 && l7<l6 && l6<l5 && l5>l4 && l4<l3)
   )))opensell=false;
   
   double cci=iCCI(NULL,0,cciperiod,PRICE_CLOSE,shift);
   
   if(lotsoptimized)lots=NormalizeDouble((AccountBalance()/1000)*minlot*risk,lotdigits);
   if(lots<minlot)lots=minlot;if(lots>maxlot)lots=maxlot;
   
   if(tradesperbar==1 && (((TimeCurrent()-lastbuyopentime)<Period()) || ((TimeCurrent()-lastsellopentime)<Period())))tpb=1;

   if(demarkerreverse && (iDeMarker(NULL,0,demarkerperiod,demarkershift)>demarkermax || iDeMarker(NULL,0,demarkerperiod,demarkershift)<demarkermin)){reversesignals=true;}else{reversesignals=false;}
   
   bool buy=false;bool sell=false;

   if((timeframe1==false || (timeframe1 && DU1>DU1a))
   && (timeframe5==false || (timeframe5 && DU5>DU5a))
   && (timeframe15==false || (timeframe15 && DU15>DU15a))
   && (timeframe30==false || (timeframe30 && DU30>DU30a))
   && (timeframe60==false || (timeframe60 && DU60>DU60a))
   && (timeframe240==false || (timeframe240 && DU240>DU240a))
   && (timeframe1440==false || (timeframe1440 && DU1440>DU1440a))
   && (timeframe10080==false || (timeframe10080 && DU10080>DU10080a))
   && (ccifilter==false || (ccifilter && cci<oversold))
   && openbuy)if(reversesignals)sell=true;else buy=true;
   
   if((timeframe1==false || (timeframe1 && DD1<DD1a))
   && (timeframe5==false || (timeframe5 && DD5<DD5a))
   && (timeframe15==false || (timeframe15 && DD15<DD15a))
   && (timeframe30==false || (timeframe30 && DD30<DD30a))
   && (timeframe60==false || (timeframe60 && DD60<DD60a))
   && (timeframe240==false || (timeframe240 && DD240<DD240a))
   && (timeframe1440==false || (timeframe1440 && DD1440<DD1440a))
   && (timeframe10080==false || (timeframe10080 && DD10080<DD10080a))
   && (ccifilter==false || (ccifilter && cci>overbought))
   && opensell)if(reversesignals)buy=true;else sell=true;

   if(bc!=Bars){tpb=0;bc=Bars;}
   /*Comment("\nSEFCU1  =  " + DoubleToStr(SEFCU1,4),"\nSEFCD1  =  " + DoubleToStr(SEFCD1,4));*/

   if((oppositeclose && sell)||(closebuy)){
      for(i=total-1;i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY){
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage*pt);
         }
      }
   }
   if((oppositeclose && buy)||(closesell)){
      for(j=total-1;j>=0;j--){
         OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL){
            OrderClose(OrderTicket(),OrderLots(),Ask,slippage*pt);
         }
      }
   }
   if(timeout){
      for(k=total-1;k>=0;k--){
         OrderSelect(k,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY && (TimeCurrent()-OrderOpenTime())>=closeafterminutes*60){
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage*pt);
         }
      }
      for(l=total-1;l>=0;l--){
         OrderSelect(l,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL&& (TimeCurrent()-OrderOpenTime())>=closeafterminutes*60){
            OrderClose(OrderTicket(),OrderLots(),Ask,slippage*pt);
         }
      }
   }
   
   if(hidestop){
      for(k=total-1;k>=0;k--){
         OrderSelect(k,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY && buystop>0 && Bid<(OrderOpenPrice()-buystop*pt)){
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage*pt);
         }
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL && sellstop>0 && Ask>(OrderOpenPrice()+sellstop*pt)){
            OrderClose(OrderTicket(),OrderLots(),Ask,slippage*pt);
         }
      }
   }
   if(hidetarget){
      for(l=total-1;l>=0;l--){
         OrderSelect(l,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY && buytarget>0 && Bid>(OrderOpenPrice()+buytarget*pt)){
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage*pt);
         }
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL && selltarget>0 && Ask<(OrderOpenPrice()-selltarget*pt)){
           OrderClose(OrderTicket(),OrderLots(),Ask,slippage*pt);
         }
      }
   }

   if((Ask-Bid)>=maxspread*pt)return(0);
   
   if((count(OP_BUY,magic)+count(OP_SELL,magic))<maxtrades){  
      if(buy && tpb<tradesperbar && IsTradeAllowed()&& checktime()){
         while(IsTradeContextBusy())Sleep(3000);
         if(hidestop==false&&buystop>0){sl=Ask-buystop*pt;}else{sl=0;}
         if(hidetarget==false&&buytarget>0){tp=Ask+buytarget*pt;}else{tp=0;}
         RefreshRates();ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,slippage*mt,sl,tp,comment+". Magic: "+DoubleToStr(magic,0),magic,0,Blue);
         if(ticket<=0){Print("Error Occured : "+errordescription(GetLastError()));}
         else{tpb++;Print("Order opened : "+Symbol()+" Buy @ "+Ask+" SL @ "+sl+" TP @"+tp+" ticket ="+ticket);}
      }
      if(sell && tpb<tradesperbar && IsTradeAllowed()&& checktime()){
         while(IsTradeContextBusy())Sleep(3000);
         if(hidestop==false&&sellstop>0){sl=Bid+sellstop*pt;}else{sl=0;}
         if(hidetarget==false&&selltarget>0){tp=Bid-selltarget*pt;}else{tp=0;}
         RefreshRates();ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,slippage*mt,sl,tp,comment+". Magic: "+DoubleToStr(magic,0),magic,0,Red);
         if(ticket<=0){Print("Error Occured : "+errordescription(GetLastError()));}
         else{tpb++;Print("Order opened : "+Symbol()+" Sell @ "+Ask+" SL @ "+sl+" TP @"+tp+" ticket ="+ticket);}
      }
   }
   return(0);
}

int checktime(){
   if(TimeCurrent()<win[TimeYear(TimeCurrent())-1999] && TimeCurrent()>sum[TimeYear(TimeCurrent())-1999])gmtshift=summergmtshift;
   else gmtshift=wintergmtshift;
   
   string time="";
   string svrdate = Year()+"."+Month()+"."+Day();

   if(mondayfilter){
      nmondayhour=mondayhour+(gmtshift);if(nmondayhour>23)nmondayhour=nmondayhour-24;
      if(nmondayhour<10)imondayhour="0"+nmondayhour;
      if(nmondayhour>9)imondayhour=nmondayhour;
      if(mondayminute<10)imondayminute="0"+mondayminute;
      if(mondayminute>9)imondayminute=mondayminute;
      tmonday=StrToTime(svrdate+" "+imondayhour+":"+imondayminute);
   }
   if(weekfilter){
      nstarthour=starthour+(gmtshift);if(nstarthour>23)nstarthour=nstarthour-24;
      if(nstarthour<10)istarthour="0"+nstarthour;
      if(nstarthour>9)istarthour=nstarthour;
      if(startminute<10)istartminute="0"+startminute;
      if(startminute>9)istartminute=startminute;
      tstart=StrToTime(svrdate+" "+istarthour+":"+istartminute);

      nendhour=endhour+(gmtshift);if(nendhour>23)nendhour=nendhour-24;
      if(endhour<10)iendhour="0"+nendhour;
      if(endhour>9)iendhour=nendhour;
      if(endminute<10)iendminute="0"+endminute;
      if(endminute>9)iendminute=endminute;
      tend=StrToTime(svrdate+" "+iendhour+":"+iendminute);
   }
   if(fridayfilter){
      nfridayhour=fridayhour+(gmtshift);if(nfridayhour>23)nfridayhour=nfridayhour-24;
      if(nfridayhour<10)ifridayhour="0"+nfridayhour;
      if(nfridayhour>9)ifridayhour=nfridayhour;
      if(fridayminute<10)ifridayminute="0"+fridayminute;
      if(fridayminute>9)ifridayminute=fridayminute;
      tfriday=StrToTime(svrdate+" "+ifridayhour+":"+ifridayminute);
   }
   if(nstarthour>nendhour && TimeCurrent()<tstart && TimeCurrent()>tend)time="DONT TRADE";else time="TRADE";
   //Comment("\nCurrentTime = "+TimeCurrent(),"\ntstart = "+tstart,"\ntend = "+tend,"\nTimeFilter = "+time);
   if((weekfilter && (nstarthour<=nendhour && TimeCurrent()<tstart || TimeCurrent()>tend) || (nstarthour>nendhour && TimeCurrent()<tstart && TimeCurrent()>tend))
   || (tradesunday==false && DayOfWeek()==0) || (fridayfilter && DayOfWeek()==5 && TimeCurrent()>tfriday) || (mondayfilter && DayOfWeek()==1 && TimeCurrent()<tmonday))return(0);
   return(1);
}

int count(int type,int magic){
   int cnt;cnt=0;
   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==type && ((OrderMagicNumber()==magic)||magic==0)){
         cnt++;
      }
   }
   return(cnt);
}

string errordescription(int code)
{
   string error;
   switch(code)
   {
      case 0:
      case 1:error="no error";break;
      case 2:error="common error";break;
      case 3:error="invalid trade parameters";break;
      case 4:error="trade server is busy";break;
      case 5:error="old version of the client terminal";break;
      case 6:error="no connection with trade server";break;
      case 7:error="not enough rights";break;
      case 8:error="too frequent requests";break;
      case 9:error="malfunctional trade operation";break;
      case 64:error="account disabled";break;
      case 65:error="invalid account";break;
      case 128:error="trade timeout";break;
      case 129:error="invalid price";break;
      case 130:error="invalid stops";break;
      case 131:error="invalid trade volume";break;
      case 132:error="market is closed";break;
      case 133:error="trade is disabled";break;
      case 134:error="not enough money";break;
      case 135:error="price changed";break;
      case 136:error="off quotes";break;
      case 137:error="broker is busy";break;
      case 138:error="requote";break;
      case 139:error="order is locked";break;
      case 140:error="long positions only allowed";break;
      case 141:error="too many requests";break;
      case 145:error="modification denied because order too close to market";break;
      case 146:error="trade context is busy";break;
      case 4000:error="no error";break;
      case 4001:error="wrong function pointer";break;
      case 4002:error="array index is out of range";break;
      case 4003:error="no memory for function call stack";break;
      case 4004:error="recursive stack overflow";break;
      case 4005:error="not enough stack for parameter";break;
      case 4006:error="no memory for parameter string";break;
      case 4007:error="no memory for temp string";break;
      case 4008:error="not initialized string";break;
      case 4009:error="not initialized string in array";break;
      case 4010:error="no memory for array\' string";break;
      case 4011:error="too long string";break;
      case 4012:error="remainder from zero divide";break;
      case 4013:error="zero divide";break;
      case 4014:error="unknown command";break;
      case 4015:error="wrong jump (never generated error)";break;
      case 4016:error="not initialized array";break;
      case 4017:error="dll calls are not allowed";break;
      case 4018:error="cannot load library";break;
      case 4019:error="cannot call function";break;
      case 4020:error="expert function calls are not allowed";break;
      case 4021:error="not enough memory for temp string returned from function";break;
      case 4022:error="system is busy (never generated error)";break;
      case 4050:error="invalid function parameters count";break;
      case 4051:error="invalid function parameter value";break;
      case 4052:error="string function internal error";break;
      case 4053:error="some array error";break;
      case 4054:error="incorrect series array using";break;
      case 4055:error="custom indicator error";break;
      case 4056:error="arrays are incompatible";break;
      case 4057:error="global variables processing error";break;
      case 4058:error="global variable not found";break;
      case 4059:error="function is not allowed in testing mode";break;
      case 4060:error="function is not confirmed";break;
      case 4061:error="send mail error";break;
      case 4062:error="string parameter expected";break;
      case 4063:error="integer parameter expected";break;
      case 4064:error="double parameter expected";break;
      case 4065:error="array as parameter expected";break;
      case 4066:error="requested history data in update state";break;
      case 4099:error="end of file";break;
      case 4100:error="some file error";break;
      case 4101:error="wrong file name";break;
      case 4102:error="too many opened files";break;
      case 4103:error="cannot open file";break;
      case 4104:error="incompatible access to a file";break;
      case 4105:error="no order selected";break;
      case 4106:error="unknown symbol";break;
      case 4107:error="invalid price parameter for trade function";break;
      case 4108:error="invalid ticket";break;
      case 4109:error="trade is not allowed";break;
      case 4110:error="longs are not allowed";break;
      case 4111:error="shorts are not allowed";break;
      case 4200:error="object is already exist";break;
      case 4201:error="unknown object property";break;
      case 4202:error="object is not exist";break;
      case 4203:error="unknown object type";break;
      case 4204:error="no object name";break;
      case 4205:error="object coordinates error";break;
      case 4206:error="no specified subwindow";break;
      default:error="unknown error";
   }
   return(error);
}  